// Sample Gauges main program
// QT4 - Experimental stage!!

#include <QtGui>
#include <math.h>
#include "sample.h"

mysample::mysample(QMainWindow *parent){

  // Setup Variables
  PI=4.*atan(1.);

  // Setup GUI
  setupUi(this);

  // Setup connections
  connect(dial, SIGNAL(valueChanged(int)), this, SLOT( moved() ));
  connect(pushButton, SIGNAL(clicked()), this, SLOT( setdialclick()) );
  connect(checkBox, SIGNAL(stateChanged(int)), this, SLOT( update()) );
}

void mysample::moved(){

  //printf("You moved the dial!! Value is %i\n",dial->value());
  update();
}


void mysample::setdialclick(){
  dial->setValue(25);
}

void mysample::paintEvent(QPaintEvent *event){
  // This is the easiest way to implement drawing (and is actually fairly convenient!)
  int x0, y0, i, imax, r;
  double d, w1, l;
  double x1, y1, x2, y2, rt;
  imax=30;
  w1=15.;
  x0=370; y0=170; r=100;
  char text[10];
  QPainter painter(this);
  QPointF inner_chevron[imax], outer_chevron[imax];

//Setup the painter to give best results...
  painter.setRenderHint(QPainter::Antialiasing, checkBox->isChecked());

// Draw an artistic gauge with centre at x0,y0
  painter.drawEllipse(x0-r,y0-r,r*2,r*2);
// Outer Line of chevron
  for (i=0;i<imax;i++){
    l=(double)i/(double)(imax-1);
    d=330.*l+15.;
    x1=sin(d*PI/180.)*(0.6*(double)r+l*w1/2.);
    y1=cos(d*PI/180.)*(0.6*(double)r+l*w1/2.);
    outer_chevron[i]=QPointF(x0+x1,y0-y1);

    x1=sin(d*PI/180.)*(0.6*(double)r-l*w1/2.);
    y1=cos(d*PI/180.)*(0.6*(double)r-l*w1/2.);
    inner_chevron[i]=QPointF(x0+x1,y0-y1);
  }
  painter.drawPolyline(inner_chevron,imax);
  painter.drawPolyline(outer_chevron,imax);
  painter.drawLine(inner_chevron[imax-1],outer_chevron[imax-1]);

  // For the next part, the scale (and arrow position) will be based on the value of the dial

  imax=dial->maximum()-dial->minimum();
  for (i=0;i<imax;i++){
    l=(double)i/(double)(imax-1);
    d=330.*l+15.;
    rt=.95;
    if ( (double)i/10. == i/10) rt=.9;
    x1=sin(d*PI/180.)*(double)r;
    y1=cos(d*PI/180.)*(double)r;
    x2=sin(d*PI/180.)*(double)r*rt;
    y2=cos(d*PI/180.)*(double)r*rt;
    painter.drawLine(x0+(int)x1,y0-(int)y1, x0+(int)x2,y0-(int)y2);

    if ( (double)i/10. == i/10) {
      sprintf(text,"%i",i);
      x1=sin(d*PI/180.)*(double)r*.75;
      y1=cos(d*PI/180.)*(double)r*.75;
      painter.drawText(x0+x1-10,y0-y1-7,20,14,Qt::AlignHCenter || Qt::AlignVCenter,text);
    }
  }

  // We want the text forward of the dial background, but behind the arrow
  painter.drawText(x0-50,y0+r/4,100,20,Qt::AlignHCenter,"Demo Dial");

  d=330.*(double)dial->value()/(double)imax+15.;

  // next we draw the arrow (this is a simple arrow with a (filled) circle at the centre of the gauge
  // and a circle just before the end.
  painter.drawEllipse(x0-2,y0-2,4,4);
  x1=sin(d*PI/180.)*(0.65*r-4.);
  y1=cos(d*PI/180.)*(0.65*r-4.);
  painter.drawLine(x0,y0,x0+x1,y0-y1);

  x1=sin(d*PI/180.)*(0.65*r);
  y1=cos(d*PI/180.)*(0.65*r);
  painter.drawEllipse(x0+x1-4,y0-y1-4,8,8);

  x1=sin(d*PI/180.)*(0.65*r+4.);
  y1=cos(d*PI/180.)*(0.65*r+4.);
  x2=sin(d*PI/180.)*(0.75*r);
  y2=cos(d*PI/180.)*(0.75*r);
  painter.drawLine(x0+x1,y0-y1, x0+x2,y0-y2);

}
